package com.steerinfo.baseinfo.meterbaserailwayhistaredata.controller;

import com.steerinfo.baseinfo.meterbasehistaredata.model.MeterBaseHisTareData;
import com.steerinfo.baseinfo.meterbaserailwayhistaredata.model.MeterBaseRailwayHisTareData;
import com.steerinfo.baseinfo.meterbaserailwayhistaredata.service.IMeterBaseRailwayHisTareDataService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseRailwayHisTareData RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-24 10:04
 * 类描述
 * 修订历史：
 * 日期：2022-03-24
 * 作者：generator
 * 参考：
 * 描述：MeterBaseRailwayHisTareData RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaserailwayhistaredatas")
public class MeterBaseRailwayHisTareDataController extends BaseRESTfulController {

    @Autowired
    IMeterBaseRailwayHisTareDataService meterBaseRailwayHisTareDataService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayhistaredata:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayHisTareData> list = meterBaseRailwayHisTareDataService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayhistaredata:view")
    @PostMapping(value = "/like/")
    public RESTfulResult listLike(@RequestBody(required = false) HashMap params){
        PageList<MeterBaseRailwayHisTareData> list = meterBaseRailwayHisTareDataService.getList(params);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseRailwayHisTareData对象创建")
    @ApiImplicitParam(name = "meterBaseRailwayHisTareData", value = "详细实体meterBaseRailwayHisTareData", required = true, dataType = "MeterBaseRailwayHisTareData")
    //@RequiresPermissions("meterbaserailwayhistaredata:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseRailwayHisTareData model){
        MeterBaseRailwayHisTareData meterBaseRailwayHisTareData = meterBaseRailwayHisTareDataService.add(model);
        return success(meterBaseRailwayHisTareData);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayhistaredata:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseRailwayHisTareData meterBaseRailwayHisTareData = meterBaseRailwayHisTareDataService.getById(id);
        return success(meterBaseRailwayHisTareData);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseRailwayHisTareData信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseRailwayHisTareData", value = "详细实体meterBaseRailwayHisTareData", required = true, dataType = "MeterBaseRailwayHisTareData")
    })
    //@RequiresPermissions("meterbaserailwayhistaredata:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseRailwayHisTareData model){
        model.setId(id);
        MeterBaseRailwayHisTareData meterBaseRailwayHisTareData = meterBaseRailwayHisTareDataService.modify(model);
        return success(meterBaseRailwayHisTareData);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayhistaredata:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseRailwayHisTareDataService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="根据火车车号和计量重量保存历史皮重", notes="根据火车车号和计量重量保存历史皮重")
    @PostMapping(value = "railwayHisTare")//String
    public RESTfulResult railwayHisTare(@RequestBody HashMap params){
        RESTfulResult rm = failed();

        String railwayNo = params.get("railwayNo") == null ? "" : params.get("railwayNo").toString();
        String meterWeight = params.get("meterWeight") == null ? "" : params.get("meterWeight").toString();
        String meterName = params.get("meterName") == null ? "" : params.get("meterName").toString();
        String baseSpotNo = params.get("baseSpotNo") == null ? "" : params.get("baseSpotNo").toString();
        String baseSpotName = params.get("baseSpotName") == null ? "" : params.get("baseSpotName").toString();
        rm = meterBaseRailwayHisTareDataService.railwayHisTare(railwayNo, meterWeight,meterName, baseSpotNo, baseSpotName);

        return rm;
    }

    @ApiOperation(value = "启用-网页", notes = "根据传过来的MeterBaseHisTareData集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseRailwayHisTareData", value = "详细实体MeterBaseRailwayHisTareData", required = true, dataType = "MeterBaseRailwayHisTareData")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody MeterBaseRailwayHisTareData model) {
        try {
            String msg = meterBaseRailwayHisTareDataService.Recovery(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "逻辑删除-网页", notes = "根据传过来的MeterBaseHisTareData集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseRailwayHisTareData", value = "详细实体MeterBaseRailwayHisTareData", required = true, dataType = "MeterBaseRailwayHisTareData")
    })
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody MeterBaseRailwayHisTareData model) {
        try {
            String msg = meterBaseRailwayHisTareDataService.abolish(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }
}
